format   pe console
include 'win32ax.inc'
include 'equates\iphlpapi.inc'
include 'equates\setupapi.inc'
entry    start
;//-----------
section '.data' data readable writeable
ai             IP_ADAPTER_INFO
devInfo        SP_DEVINFO_DATA
memStat        MEMORYSTATUS_EX
dispDev        DISPLAY_DEVICEA

align  16
struct DISK_GEOMETRY
  totalCyl    dd  0,0   ; - 
  mediaType   dd  0     ; -  
  trackCyl    dd  0     ; -  ()  
  secTrack    dd  0     ; -   
  byteSec     dd  0     ; -   
ends
diskGeo        DISK_GEOMETRY
IOCTL_DISK_GET_DRIVE_GEOMETRY = 0x00070000

sizePointer    dd  0
hndl           dd  0
type           dd  0
mByte          dd  1024*1024
gByte          dd  1024*1024*1024
result         dq  0
buff           db  0
;//-----------
section '.text' code readable executable
start:   invoke  SetConsoleTitle,<'*** Virtual Machine & Sandbox Detect ***',0>

if 0
;//-----   ----------------------------
        cinvoke  printf,<10,' Environment:',0>
         mov     ebx,[ fs:0x30]      ;// PEB
         mov     ebx,[ebx+0x10]      ;// PEB.ProcessParameters
         mov     esi,[ebx+0x48]      ;// PEB.ProcessParameters.Environment
         mov     ecx,4
@@:      push    esi ecx
        cinvoke  printf,<10,'     %ls',0>,esi
         pop     ecx esi
         sub     eax,5
         shl     eax,1
         add     esi,eax
         loop    @b
end if

;//-----    -------------------------------
         mov     edi,buff
         mov     ecx,3
         mov     eax,0x80000002
@@:      push    eax ecx
         cpuid
         stosd
         xchg    eax,ebx
         stosd
         xchg    eax,ecx
         stosd
         xchg    eax,edx
         stosd
         pop     ecx eax
         inc     eax
         loop    @b
        cinvoke  printf,<10,' CPU name string.....: %s',0>,buff

         mov     eax,[fs:30h]
         mov     eax,[eax+64h]
        cinvoke  printf,<10,' CPU cores...........: %d',0>,eax
         rdtsc
         push    eax
         invoke  Sleep,1000
         rdtsc
         pop     ebx
         sub     eax,ebx
         shr     eax,20
        cinvoke  printf,<10,' CPU frequency.......: %d.0 MHz',0>,eax

;//-----   -----------------------------------
         invoke  GlobalMemoryStatusEx,memStat
         push    dword[memStat.dqTotalPhys+4]
         push    dword[memStat.dqTotalPhys]
         fild    qword[esp]
         fidiv   [mByte]
         fstp    [result]
         add     esp,8
        cinvoke  printf,<10,' Physical memory.....: %.1f Mb',0>,\
                         dword[result],dword[result+4]

;//-----    ---------------------------------
        cinvoke  printf,<10,' Check 1 sec delay...: ',0>
         invoke  GetTickCount
         push    eax
         invoke  Sleep,1000
         invoke  GetTickCount
         pop     ebx
         sub     eax,ebx
        cinvoke  printf,<'%4u.0 msec',0>,eax

;//----- NetBios   --------------------------
         mov     [sizePointer],128
         invoke  GetComputerName,buff,sizePointer
         invoke  CharToOem,buff,buff
        cinvoke  printf,<10,10,' Computer name.......: %s',0>,buff

;//-----   -----------------------------
         invoke  EnumDisplayDevices,0,0,dispDev,1
         lea     ebx,[dispDev.DeviceString]
        cinvoke  printf,<10,' Display device......: %s',0>,ebx
         invoke  GetSystemMetrics,SM_CXSCREEN
         push    eax
         invoke  GetSystemMetrics,SM_CYSCREEN
         pop     ebx
        cinvoke  printf,<'. %d x %d',0>,ebx,eax

;//-----     --------------------------
         call    ClearBuff
         invoke  RegOpenKeyEx,HKEY_LOCAL_MACHINE,<'Hardware\Description\System',0>,0,KEY_ALL_ACCESS,hndl
         mov     [sizePointer],64
         invoke  RegQueryValueEx,[hndl],<'SystemBiosVersion',0>,0,type,buff,sizePointer
        cinvoke  printf,<10,' Bios Version........: %s',10,0>,buff

;//-----    CD  SetupApi.dll ---------------
         call    ClearBuff
         invoke  SetupDiGetClassDevs,GUID_DEVCLASS_CDROM,0,0,DIGCF_PROFILE
         push    eax
         invoke  SetupDiEnumDeviceInfo,eax,0,devInfo
         pop     eax
         invoke  SetupDiGetDeviceRegistryProperty,eax,devInfo,SPDRP_FRIENDLYNAME,0,buff,128,0
        cinvoke  printf,<10,' CD/DVDROM  name.....: %s',0>,buff

         call    ClearBuff
         invoke  SetupDiGetClassDevs,GUID_DEVCLASS_DISKDRIVE,0,0,DIGCF_PRESENT
         push    eax
         invoke  SetupDiEnumDeviceInfo,eax,0,devInfo
         pop     eax
         invoke  SetupDiGetDeviceRegistryProperty,eax,devInfo,SPDRP_FRIENDLYNAME,0,buff,128,0
        cinvoke  printf,<10,' Hard drive name.....: %s',0>,buff

;//-----   ------------------------------------
         call    ClearBuff
         invoke  CreateFile,<'\\.\PhysicalDrive0',0>,0,FILE_SHARE_READ + FILE_SHARE_WRITE,\
                             0,OPEN_EXISTING,0,0
         push    eax
         invoke  DeviceIoControl,eax,IOCTL_DISK_GET_DRIVE_GEOMETRY,\
                                 0,0,diskGeo,sizeof.DISK_GEOMETRY,type,0
         pop     eax
         invoke  CloseHandle,eax

         mov     eax,[diskGeo.byteSec]
         imul    eax,[diskGeo.secTrack]
         imul    eax,[diskGeo.trackCyl]
         mov     [type],eax

         fild    qword[diskGeo.totalCyl]
         fimul   [type]
         fidiv   [gByte]
         fstp    [result]
        cinvoke  printf, <10,' Hard drive size.....: %.1f Gb',10,0>,dword[result],dword[result+4]

;//-----    -------------------------------
         invoke  GetAdaptersInfo,ai,sizePointer
         invoke  GetAdaptersInfo,ai,sizePointer
         movzx   eax,[ai.Address+0]
         movzx   ebx,[ai.Address+1]
         movzx   ecx,[ai.Address+2]
         movzx   edx,[ai.Address+3]
         movzx   esi,[ai.Address+4]
         movzx   edi,[ai.Address+5]
        cinvoke  printf,<10,' NIC MAC address.....: %02x:%02x:%02x:%02x:%02x:%02x',\
                         10,'                       --------',\
                         10,'                       08:00:27: <----- VBox   v5.2',\
                         10,'                       00:21:f6:               v3.3',\
                         10,'                       52:54:00:               Vagrant or QEMU',\
                         10,'                       --------',\
                         10,'                       00:50:56: <----- VMware Workstation',\
                         10,'                       00:0c:29:               ESXi Host ',\
                         10,'                       00:05:69:               ESXi,GSX',\
                         10,'                       00:1c:14:               VMware',10,0>,\
                         eax,ebx,ecx,edx,esi,edi

;//-----   Windows\system32 -------------------
         call    ClearBuff
         invoke  FindFirstFile,<'C:\Windows\System32\VBox*.dll',0>,buff
         mov     [hndl],eax
        cinvoke  printf,<10,' VBox \System32 dll..: %s',0>,buff+44
         cmp     [hndl],0
         jz      @f
@next:   invoke  FindNextFile,[hndl],buff
         or      eax,eax
         jz      @f
        cinvoke  printf,<10,23 dup(' '),'%s',0>,buff+44
         jmp     @next
@@:      invoke  CloseHandle,[hndl]

;//----- Sandbox -     ------
        cinvoke  printf,<10,10,' Sandboxie dll test..: ',0>
         invoke  GetCurrentProcess
         invoke  EnumerateLoadedModules,eax,EnumCallback,0

;//-----    Desktop -------------
        cinvoke  printf,<10,' Sandboxie Desktop...: ',0>
         invoke  EnumDesktops,0,DesktopCallback,0

@exit:  cinvoke  _getch
        cinvoke  exit, 0

;//********************************************************
proc  ClearBuff
         mov     edi,buff
         mov     ecx,128/4
         xor     eax,eax
         rep     stosd
         ret
endp
proc  EnumCallback Name,Base,Size,Context
         mov     esi,[Name]
@@:      lodsb
         or      al,al
         jnz     @b
         sub     esi,12
         lodsd
         cmp     eax,'Sbie'
         jnz     @01
         sub     esi,4
        cinvoke  printf,<'%s <--- Found!',0>,esi
@01:     mov     eax,1
         ret
endp
proc  DesktopCallback Desktop,lParam
         push    esi
         mov     esi,[Desktop]
         cmp     dword[esi],'Defa'
         jnz     @02
        cinvoke  printf,<'%s <------- Found! ',0>,[Desktop]
@02:     pop     esi
         mov     eax,1
         ret
endp
;//********************************************************

section '.idata' import data readable writeable
library  msvcrt,'msvcrt.dll',kernel32,'kernel32.dll',\
         user32,'user32.dll',iphlpapi,'iphlpapi.dll',\
         advapi32,'advapi32.dll',setupapi,'setupapi.dll',dbghelp,'dbghelp.dll'
import   dbghelp, EnumerateLoadedModules,'EnumerateLoadedModules'
include 'api\msvcrt.inc'
include 'api\kernel32.inc'
include 'api\user32.inc'
include 'api\iphlpapi.inc'
include 'api\setupapi.inc'
include 'api\advapi32.inc'
